"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _factory = require("./variate/factory");

var _factory2 = _interopRequireDefault(_factory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Variate = function () {
  function Variate() {
    _classCallCheck(this, Variate);
  }

  _createClass(Variate, [{
    key: "convert",
    value: function convert(_ref) {
      var args = _ref.args;
      var _ref$include = _ref.include;
      var callbackStore = _ref$include.callbackStore;
      var cookie = _ref$include.cookie;
      var _ref$state = _ref.state;
      var callback = _ref$state.callback;
      var tests = _ref$state.tests;

      if (typeof document == "undefined") {
        return;
      }

      args = _extends({}, args, this.getTest(args), cookie().read(args));

      if (!args.variant) {
        throw new Error("convert() called before test()");
      }

      return callbackStore().run(_extends({}, args, { converted: true }));
    }
  }, {
    key: "getTest",
    value: function getTest(_ref2) {
      var name = _ref2.name;
      var tests = _ref2.state.tests;

      var test = tests[name];

      if (!test) {
        throw new Error("test not found");
      }

      return { test: test };
    }
  }, {
    key: "randomVariant",
    value: function randomVariant(_ref3) {
      var test = _ref3.test;

      var index = Math.random() * test.length;
      index = Math.floor(index);

      if (typeof document == "undefined") {
        index = 0;
      }

      return { variant: test[index] };
    }
  }, {
    key: "test",
    value: function test(_ref4) {
      var args = _ref4.args;
      var _ref4$include = _ref4.include;
      var callbackStore = _ref4$include.callbackStore;
      var cookie = _ref4$include.cookie;
      var tests = _ref4.state.tests;

      args = _extends({}, args, this.getTest(args), cookie().read(args));

      if (!args.variant) {
        args = _extends({}, args, this.randomVariant(args));
        cookie().write(args);
      }

      callbackStore().run(args);

      return args.variant;
    }
  }, {
    key: "updated",
    value: function updated(_ref5) {
      var state = _ref5.state;
      var _ref5$include = _ref5.include;
      var callbackStore = _ref5$include.callbackStore;
      var cookie = _ref5$include.cookie;

      callbackStore(state);
      cookie(state);
    }
  }]);

  return Variate;
}();

exports.default = (0, _factory2.default)(Variate);
//# sourceMappingURL=variate.js.map